
ShowOpenDialog proc hWnd:HWND, Filter:DWORD, InitialDir:DWORD, PathBuffer:DWORD
	LOCAL	ofn		:OPENFILENAME
	
	invoke	RtlZeroMemory, addr ofn, sizeof OPENFILENAME
	mov		ofn.lStructSize, sizeof OPENFILENAME
	mov		ofn.Flags, OFN_HIDEREADONLY; or OFN_NOCHANGEDIR ;OFN_NODEREFERENCELINKS or OFN_FILEMUSTEXIST OFN_PATHMUSTEXIST or OFN_CREATEPROMPT or
	m2m		ofn.hwndOwner, hWnd
	m2m		ofn.hInstance, hInstance
	m2m		ofn.lpstrFilter, Filter
	m2m		ofn.lpstrFile, PathBuffer
	m2m		ofn.lpstrInitialDir, InitialDir
	mov		ofn.nMaxFile, 256
	invoke	GetOpenFileName, addr ofn
	.if eax!=0
		mov		eax, ofn.nFilterIndex
	.endif
	ret

ShowOpenDialog endp


DoToolBar proc hTBr:HWND, Img:DWORD, NmBtn:DWORD, tbbtns:DWORD 
	LOCAL	hImageList	:DWORD
	LOCAL	tbab		:TBADDBITMAP

	invoke	SendMessage, hTBr, TB_BUTTONSTRUCTSIZE, sizeof TBBUTTON, 0
	mov		ecx, 16
	mov		eax, 16
	shl		eax, 16
	mov		ax, cx
	invoke	SendMessage, hTBr, TB_SETBITMAPSIZE, 0, eax
	invoke	ImageList_Create, 16, 16, ILC_MASK or ILC_COLORDDB, 20, 20 ; 
	mov		hImageList, eax
	invoke	ImageList_AddMasked, hImageList, Img, 00FF00FFh
	invoke	SendMessage, hTBr, TB_SETIMAGELIST, 0, hImageList
	invoke	DeleteObject, Img
	invoke	SendMessage, hTBr, TB_SETBUTTONSIZE, 16, 16	
	invoke	SendMessage, hTBr, TB_ADDBUTTONS, NmBtn, tbbtns
	mov		eax, hTBr
	ret
	
DoToolBar endp


InitActionMenu proc hActMenu:DWORD, hWndHandle:DWORD 
	
	.if NTPlatformId==0
		mov		eax, MF_GRAYED
	.else
		mov		eax, MF_ENABLED
	.endif
	invoke	EnableMenuItem, hActMenu, IDM_ATRANSPARENT, eax
	
	invoke	IsWindowEnabled, hWndHandle
	imul	eax, MF_CHECKED 
	invoke	CheckMenuItem, hActMenu, IDM_AENABLE, eax
	
	invoke	SendMessage, hWndHandle, BM_GETCHECK, 0, 0
	imul	eax, MF_CHECKED
	invoke	CheckMenuItem, hActMenu, IDM_ACHECK, eax
	
	invoke	IsWindowVisible, hWndHandle
	xor		eax, TRUE
	imul	eax, MF_CHECKED 
	invoke	CheckMenuItem, hActMenu, IDM_AHIDE, eax
	
	invoke	GetWindowLong, hWndHandle, GWL_EXSTYLE
	test	eax, WS_EX_TOPMOST
	.if !(ZERO?)
		mov		eax, MF_CHECKED
	.else
		mov		eax, MF_UNCHECKED
	.endif
	invoke	CheckMenuItem, hActMenu, IDM_ATOPMOST, eax
	
	invoke	GetWindowLong, hWndHandle, GWL_STYLE
	test	eax, ES_READONLY
	.if !(ZERO?)
		mov		eax, MF_CHECKED
	.else
		mov		eax, MF_UNCHECKED
	.endif
	invoke	CheckMenuItem, hActMenu, IDM_AREADONLY, eax

	invoke	CheckMenuItem, hActMenu, IDM_ASTATENORMAL, MF_UNCHECKED
	invoke	CheckMenuItem, hActMenu, IDM_ASTATEMAX, MF_UNCHECKED
	invoke	CheckMenuItem, hActMenu, IDM_ASTATEMIN, MF_UNCHECKED
	invoke	IsIconic, hWndHandle
	.if eax!=0
		invoke	CheckMenuItem, hActMenu, IDM_ASTATEMIN, MF_CHECKED
	.else
		invoke	IsZoomed, hWndHandle
		.if eax!=0
			invoke	CheckMenuItem, hActMenu, IDM_ASTATEMAX, MF_CHECKED
		.else
			invoke	CheckMenuItem, hActMenu, IDM_ASTATENORMAL, MF_CHECKED
		.endif
	.endif
	ret

InitActionMenu endp


CaptureDesktop proc hWnd:HWND
	LOCAL	hdc		:DWORD
	
	invoke	GetWindowDC, hWndDesktop
	mov		hdc, eax
	invoke	CreateCompatibleDC, eax
	mov		hDCBmpScreen, eax	
	push	0
	invoke	GetDeviceCaps, hdc, BITSPIXEL
	push	eax
	invoke	GetDeviceCaps, hdc, PLANES
	push	eax
	invoke	GetDeviceCaps, hdc, VERTRES
	mov		ScreenHeight, eax
	push	eax
	invoke	GetDeviceCaps, hdc, HORZRES
	mov		ScreenWidth, eax
	push	eax
	call	CreateBitmap
	mov		hScreenBmp, eax
	invoke	SelectObject, hDCBmpScreen, eax
	invoke	BitBlt, hDCBmpScreen, 0, 0, ScreenWidth, ScreenHeight, hdc, 0, 0, SRCCOPY
	ret

CaptureDesktop endp


PaintDesktopCapture proc

	invoke	GetWindowDC, hWndDesktop
	invoke	BitBlt, eax, 0, 0, ScreenWidth, ScreenHeight, hDCBmpScreen, 0, 0, SRCCOPY
	ret
	
PaintDesktopCapture endp


FreeCaptureDesktop proc
	
	invoke	DeleteObject, hDCBmpScreen
	invoke	DeleteObject, hScreenBmp
	ret

FreeCaptureDesktop endp


;------------------------------------------------------
; This function will detect any window under cursor  
; including disabled or hidden window
;------------------------------------------------------

ChildWindowUnderCursor proc uses ebx
	LOCAL	hWndParent	:DWORD
	LOCAL	rect		:RECT
	LOCAL	pt			:POINT

	mov		hWndResult, 0
	mov		rWidth, -1
	mov		rHeight, -1

	invoke	GetCursorPos, addr pt
	invoke	WindowFromPoint, pt.x, pt.y
	mov		hWndParent, eax
	invoke	GetWindow, eax, GW_CHILD
	.if eax==0
		invoke	GetParent, hWndParent
		.if eax!=0
			invoke	GetWindow, eax, GW_CHILD
		.endif
	.endif
	invoke	CheckChildWindow, eax, pt.x, pt.y
	mov		eax, hWndResult
	.if eax==0
		mov		eax, hWndParent
	.endif
	ret

ChildWindowUnderCursor endp


CheckChildWindow proc hWnd:HWND, xPoint:DWORD, yPoint:DWORD
	LOCAL	hWndNext	:DWORD

	mov		eax, hWnd
	.while eax!=0
		mov		hWndNext, eax
		invoke	CompareWindowRect, eax, xPoint, yPoint
		invoke	GetWindow, hWndNext, GW_CHILD
		.if eax!=0
			invoke	CheckChildWindow, eax, xPoint, yPoint
		.endif
		invoke	GetWindow, hWndNext, GW_HWNDNEXT
	.endw
	ret

CheckChildWindow endp


CompareWindowRect proc hWnd:HWND, xPoint:DWORD, yPoint:DWORD
	LOCAL	rect	:RECT
	
	invoke	GetWindowRect, hWnd, addr rect
	mov		eax, xPoint
	.if rect.left<=eax && rect.right>=eax
		mov		edx, yPoint
		.if rect.top<=edx && rect.bottom>=edx
			mov		eax, rect.right
			sub		eax, rect.left
			mov		edx, rect.bottom
			sub		edx, rect.top
			.if eax<=rWidth && edx<=rHeight
				mov		rWidth, eax
				mov		rHeight, edx
				m2m		hWndResult, hWnd
			.endif
		.endif
	.endif
	ret

CompareWindowRect endp


PaintWindowMark proc hWnd:HWND
	LOCAL	hPen		:DWORD
	LOCAL	hOldPen		:DWORD
	LOCAL	hMemDC		:DWORD
	LOCAL	hBitmap		:DWORD
	LOCAL	hBitmapOld	:DWORD
	LOCAL	fRect		:RECT
	
	invoke	GetWindowRect, hWnd, addr fRect
	invoke	CreateCompatibleDC, hWndDesktopDC
	mov		hMemDC, eax	
	invoke	CreateCompatibleBitmap, hWndDesktopDC, ScreenWidth, ScreenHeight
	mov		hBitmap, eax
	invoke	SelectObject, hMemDC, hBitmap
	mov		hBitmapOld, eax
	invoke	CreatePen, PS_INSIDEFRAME, 4, 000000FFh
	mov		hPen, eax
	invoke	SelectObject, hMemDC, eax
	mov		hOldPen, eax
	.if WindowFocus==1
		mov		eax, R2_NOTXORPEN
	.elseif WindowFocus==2
		mov		eax, R2_NOT
	.endif
	invoke	SetROP2, hMemDC,  eax 
	invoke	BitBlt, hMemDC, 0, 0, ScreenWidth, ScreenHeight, hDCBmpScreen, 0, 0, SRCCOPY
	invoke	Rectangle, hMemDC, fRect.left, fRect.top, fRect.right, fRect.bottom
	invoke	BitBlt, hWndDesktopDC, 0, 0, ScreenWidth, ScreenHeight, hMemDC, 0, 0, SRCCOPY
	invoke	SelectObject, hMemDC, hOldPen
	invoke	DeleteObject, hPen
	invoke	SelectObject, hMemDC, hBitmapOld
	invoke	DeleteObject, hBitmap
	invoke	DeleteDC, hMemDC
	invoke	ReleaseDC, hWndDesktop, hWndDesktopDC
	ret

PaintWindowMark endp


WindowFlash proc hWnd:HWND
	LOCAL	rect			:RECT
	LOCAL	hdc				:HDC
	LOCAL	hWndhdc			:HDC
	LOCAL	hWndMemDC		:HDC
	LOCAL	hMemDC			:HDC
	LOCAL	hPen			:DWORD
	LOCAL	hOldPen			:DWORD
	LOCAL	hBitmap			:DWORD
	LOCAL	hBitmapOld		:DWORD	
	LOCAL	hWindowBmp		:DWORD
	LOCAL	WindowHeight	:DWORD
	LOCAL	WindowWidth		:DWORD
	LOCAL	FlashType		:DWORD
	LOCAL	FlashCount		:DWORD
	LOCAL	hWndParent		:DWORD
	
	invoke	ShowWindow, hWnd, SW_MINIMIZE
	
	mov		eax, hWndWindow
	.repeat
		mov		hWndParent, eax
		invoke	GetParent, hWndParent
	.until eax==NULL
	
	invoke	SetForegroundWindow, hWndParent
	
	invoke	Sleep, 100
	
	mov		FlashType, 0
	mov		FlashCount, 0
	invoke	GetWindowRect, hWndWindow, addr rect
	invoke	GetWindowDC, hWndWindow
	mov		hWndhdc, eax
	invoke	CreateCompatibleDC, eax
	mov		hWndMemDC, eax
	push	0
	invoke	GetDeviceCaps, hWndhdc, BITSPIXEL
	push	eax
	invoke	GetDeviceCaps, hWndhdc, PLANES
	push	eax
	mov		eax, rect.bottom
	sub		eax, rect.top
	mov		WindowHeight, eax
	push	eax
	mov		eax, rect.right
	sub		eax, rect.left
	mov		WindowWidth, eax
	push	eax
	call	CreateBitmap
	mov		hWindowBmp, eax
	invoke	SelectObject, hWndMemDC, eax
	invoke	BitBlt, hWndMemDC, 0, 0, WindowWidth, WindowHeight, hWndhdc, 0, 0, SRCCOPY
	
	invoke	GetWindowDC, hWndWindow
	mov		hdc, eax
	invoke	CreateCompatibleDC, hdc
	mov		hMemDC, eax	
	invoke	CreateCompatibleBitmap, hdc, WindowWidth, WindowHeight
	mov		hBitmap, eax
	invoke	SelectObject, hMemDC, hBitmap
	mov		hBitmapOld, eax

	invoke	CreatePen, PS_INSIDEFRAME, 4, 000000FFh
	mov		hPen, eax
	invoke	SelectObject, hMemDC, eax
	mov		hOldPen, eax
	invoke	SetROP2, hMemDC, R2_NOT

	.while FlashCount<=10
		.if FlashType==0
			inc		FlashType
			invoke	BitBlt, hMemDC, 0, 0, WindowWidth, WindowHeight, hWndMemDC, 0, 0, SRCCOPY
			invoke	BitBlt, hdc, 0, 0, WindowWidth, WindowHeight, hMemDC, 0, 0, SRCCOPY
		.else
			dec		FlashType
			invoke	BitBlt, hMemDC, 0, 0, WindowWidth, WindowHeight, hWndMemDC, 0, 0, SRCCOPY
			invoke	Rectangle, hMemDC, 0, 0, WindowWidth, WindowHeight
			invoke	BitBlt, hdc, 0, 0, WindowWidth, WindowHeight, hMemDC, 0, 0, SRCCOPY
		.endif
		invoke	Sleep, 150
		inc		FlashCount
	.endw
	
	invoke	SelectObject, hMemDC, hOldPen
	invoke	DeleteObject, hPen
	invoke	SelectObject, hMemDC, hBitmapOld
	invoke	DeleteObject, hBitmap
	invoke	DeleteObject, hWindowBmp
	invoke	DeleteDC, hMemDC
	invoke	DeleteDC, hWndMemDC
	invoke	ReleaseDC, hWndWindow, hdc
	
	invoke	InvalidateRect, hWndWindow, 0, TRUE
	invoke	Sleep, 20
	invoke	ShowWindow, hWnd, SW_RESTORE
	ret

WindowFlash endp


GetAllWindows proc hWnd:HWND, StartWindow:HWND, CaptureWindow:HWND, lParent:HWND
	LOCAL	hWndWindows		:HWND
	LOCAL	hParent			:HWND
	LOCAL	tvis			:TV_INSERTSTRUCT

	mov		tvis.itemex.imask, TVIF_TEXT or TVIF_SELECTEDIMAGE or TVIF_PARAM or TVIF_IMAGE 
	mov		tvis.itemex.pszText, offset TextBuff
	mov		tvis.itemex.cchTextMax, 512
	mov		tvis.itemex.iImage, 12
	mov		tvis.itemex.iSelectedImage, 12
	mov		eax, lParent
	mov		tvis.hParent, eax
	.if eax!=0
		m2m		hWndWindows, StartWindow
		mov		tvis.hInsertAfter, TVI_LAST
	.else
		mov		tvis.hInsertAfter, TVI_ROOT
	.endif
	
	mov		eax, StartWindow
	.if eax!=0
		m2m		hWndWindows, StartWindow
	.else
		invoke	GetDesktopWindow
		mov		hWndWindows, eax
	.endif

	.repeat
		m2m		tvis.itemex.lParam, hWndWindows
		invoke	GetWindowText, hWndWindows, addr WindowName, 256
		invoke	GetClassName, hWndWindows, addr ClassNm, 256
		invoke	wsprintf, addr TextBuff, addr WindowsFmt, hWndWindows, addr WindowName, addr ClassNm
		invoke	SendDlgItemMessage, hWnd, IDC_WINDOWSTRV, TVM_INSERTITEM, 0, addr tvis
		mov		hParent, eax
		mov		eax, hWndWindows
		.if eax==CaptureWindow
			m2m		CurrentItem, hParent
		.endif
		invoke	GetWindow, hWndWindows, GW_CHILD
		.if eax!=0
			invoke	GetAllWindows, hWnd, eax, CaptureWindow, hParent
		.endif
		invoke	GetWindow, hWndWindows, GW_HWNDNEXT
		mov		hWndWindows, eax
	.until eax==0
	mov		eax, hParent
	ret

GetAllWindows endp


GetChildWindows proc hWnd:HWND, StartWindow:HWND
	LOCAL	hWndWindows		:HWND
	LOCAL	hParent			:HWND
	LOCAL	tvis			:TV_INSERTSTRUCT

	mov		tvis.itemex.imask, TVIF_TEXT or TVIF_SELECTEDIMAGE or TVIF_PARAM or TVIF_IMAGE 
	mov		tvis.itemex.pszText, offset TextBuff
	mov		tvis.itemex.cchTextMax, 512
	mov		tvis.itemex.iImage, 12
	mov		tvis.itemex.iSelectedImage, 12
	mov		tvis.hParent, 0
	mov		tvis.hInsertAfter, TVI_ROOT
	
	m2m		hWndWindows, StartWindow
	m2m		tvis.itemex.lParam, hWndWindows
	invoke	GetWindowText, hWndWindows, addr WindowName, 256
	invoke	GetClassName, hWndWindows, addr ClassNm, 256
	invoke	wsprintf, addr TextBuff, addr WindowsFmt, hWndWindows, addr WindowName, addr ClassNm
	invoke	SendDlgItemMessage, hWnd, IDC_WINDOWSTRV, TVM_INSERTITEM, 0, addr tvis
	mov		hParent, eax
	invoke	GetWindow, hWndWindows, GW_CHILD
	.if eax!=0
		invoke	GetAllWindows, hWnd, eax, 0, hParent
	.endif
	mov		eax, hParent
	ret

GetChildWindows endp


ExpandTreeView proc hWnd:HWND, lParent:HWND, flag:DWORD
	LOCAL	hParent			:HWND
	LOCAL	hChildParent	:HWND
	
	.if lParent==0
		invoke	SendDlgItemMessage, hWnd, IDC_WINDOWSTRV, TVM_GETNEXTITEM, TVGN_ROOT, 0
		mov		hParent, eax
	.else
		m2m		hParent, lParent
	.endif
	
	.repeat
		invoke	SendDlgItemMessage, hWnd, IDC_WINDOWSTRV, TVM_GETNEXTITEM, TVGN_CHILD, hParent
		.if eax!=0
			mov		hChildParent, eax
			invoke	SendDlgItemMessage, hWnd, IDC_WINDOWSTRV, TVM_EXPAND, flag, hParent
			invoke	ExpandTreeView, hWnd, hChildParent, flag	
		.endif
		invoke	SendDlgItemMessage, hWnd, IDC_WINDOWSTRV, TVM_GETNEXTITEM, TVGN_NEXT, hParent
		mov		hParent, eax
	.until eax==0
	ret

ExpandTreeView endp


ShowWindowInformations proc hWnd:HWND, hWndTarget:DWORD
	
	invoke	GetWindowLong, hWndTarget, GWL_HWNDPARENT
	invoke	wsprintf, addr TextBuff, addr HexFmt, eax
	invoke	SendDlgItemMessage, hWnd, IDC_PRNTHANDLEEDT, WM_SETTEXT, 0, addr TextBuff
	invoke	wsprintf, addr TextBuff, addr HexFmt, hWndTarget
	invoke	SendDlgItemMessage, hWnd, IDC_WNDHANDLEEDT, WM_SETTEXT, 0, addr TextBuff
	invoke	GetWindowLong, hWndTarget, GWL_ID
	invoke	wsprintf, addr TextBuff, addr HexFmt, eax
	invoke	SendDlgItemMessage, hWnd, IDC_CTRLIDEDT, WM_SETTEXT, 0, addr TextBuff
	invoke	GetWindowLong, hWndTarget, GWL_HINSTANCE
	invoke	wsprintf, addr TextBuff, addr HexFmt, eax
	invoke	SendDlgItemMessage, hWnd, IDC_INSTANCEEDT, WM_SETTEXT, 0, addr TextBuff
	invoke	GetWindowLong, hWndTarget, GWL_WNDPROC
	invoke	wsprintf, addr TextBuff, addr HexFmt, eax
	invoke	SendDlgItemMessage, hWnd, IDC_WNDPROCEDT, WM_SETTEXT, 0, addr TextBuff
	invoke	GetWindowLong, hWndTarget, GWL_USERDATA
	invoke	wsprintf, addr TextBuff, addr HexFmt, eax
	invoke	SendDlgItemMessage, hWnd, IDC_USERDATAEDT, WM_SETTEXT, 0, addr TextBuff
	invoke	GetWindowLong, hWndTarget, GWL_STYLE
	invoke	wsprintf, addr TextBuff, addr HexFmt, eax
	invoke	SendDlgItemMessage, hWnd, IDC_WNDSTYLEEDT, WM_SETTEXT, 0, addr TextBuff
	invoke	GetWindowLong, hWndTarget, GWL_EXSTYLE
	invoke	wsprintf, addr TextBuff, addr HexFmt, eax
	invoke	SendDlgItemMessage, hWnd, IDC_WNDEXSTYLEEDT, WM_SETTEXT, 0, addr TextBuff
	invoke	GetClassName, hWndTarget, addr TextBuff, 256
	invoke	SendDlgItemMessage, hWnd, IDC_CLASSNAMEEDT, WM_SETTEXT, 0, addr TextBuff
	invoke	GetWindowText, hWndTarget, addr TextBuff, 256
	invoke	SendDlgItemMessage, hWnd, IDC_WINDOWTEXTEDT, WM_SETTEXT, 0, addr TextBuff
	ret

ShowWindowInformations endp


FillMessagesData proc uses ebx esi edi hWnd:HWND
	
	xor		ebx, ebx
	mov		esi, offset MessagesData
	.while byte ptr [esi]!=0
		mov		edi, offset TextBuff
		.while byte ptr [esi]!=' '
			mov		al, byte ptr [esi]
			mov		byte ptr [edi], al
			inc		esi
			inc		edi
		.endw
		mov		byte ptr [edi], 0
		invoke	SendDlgItemMessage, hWnd, IDC_SMMSGCBO, CB_ADDSTRING, 0, addr TextBuff
		mov		ebx, eax
		inc		esi
		mov		edi, offset TextBuff
		.while byte ptr [esi]!=0dh
			mov		al, byte ptr [esi]
			mov		byte ptr [edi], al
			inc		esi
			inc		edi
		.endw
		mov		byte ptr [edi], 0
		invoke	htodw, addr TextBuff
		invoke	SendDlgItemMessage, hWnd, IDC_SMMSGCBO, CB_SETITEMDATA, ebx, eax
		add		esi, 2
	.endw
	ret

FillMessagesData endp


GetStyleName proc uses ebx esi lpStyleName:DWORD, StylePos:DWORD
	
	mov		esi, lpStyleName
	mov		ebx, StylePos
	.while ebx>0
		invoke	lstrlen, esi
		inc		eax
		add		esi, eax
		dec		ebx
	.endw
	mov		eax, esi
	ret

GetStyleName endp


ShowWindowProperties proc hWnd:HWND, StartPg:DWORD
	
	mov		psp1.dwSize, sizeof PROPSHEETPAGE
	mov		psp1.dwFlags, PSP_USETITLE
	m2m		psp1.hInstance, hInstance 
	mov		psp1.pszTemplate, IDD_WNDPPRTGENERALDLG
	mov		psp1.pfnDlgProc, offset WndPprtGeneralDlg
	mov		psp1.pszTitle, offset General

	mov		psp2.dwSize, sizeof PROPSHEETPAGE
	mov		psp2.dwFlags, PSP_USETITLE
	m2m		psp2.hInstance, hInstance 
	mov		psp2.pszTemplate, IDD_WNDPPRTSTYLESDLG
	mov		psp2.pfnDlgProc, offset WndPprtStylesDlg
	mov		psp2.pszTitle, offset Styles
	
	mov		psp3.dwSize, sizeof PROPSHEETPAGE
	mov		psp3.dwFlags, PSP_USETITLE
	m2m		psp3.hInstance, hInstance 
	mov		psp3.pszTemplate, IDD_WNDPPRTWINDOWSDLG
	mov		psp3.pfnDlgProc, offset WndPprtWindowsDlg 
	mov		psp3.pszTitle, offset Windows

	mov		psp4.dwSize, sizeof PROPSHEETPAGE
	mov		psp4.dwFlags, PSP_USETITLE
	m2m		psp4.hInstance, hInstance 
	mov		psp4.pszTemplate, IDD_WNDPPRTCLASSDLG
	mov		psp4.pfnDlgProc, offset WndPprtClassDlg 
	mov		psp4.pszTitle, offset Class
	
	mov		psp5.dwSize, sizeof PROPSHEETPAGE
	mov		psp5.dwFlags, PSP_USETITLE
	m2m		psp5.hInstance, hInstance 
	mov		psp5.pszTemplate, IDD_WNDPPRTPROCESSDLG
	mov		psp5.pfnDlgProc, offset WndPprtProcessDlg 
	mov		psp5.pszTitle, offset Process
	
	mov		psh.dwSize, sizeof PROPSHEETHEADERA
	mov		psh.dwFlags, PSH_NOAPPLYNOW or PSH_PROPSHEETPAGE or PSH_USECALLBACK  
	m2m		psh.hInstance, hInstance	
	m2m		psh.hwndParent, hWnd 
	mov		psh.pfnCallback, offset PropSheetProc
	mov		psh.nPages, 5
	m2m		psh.nStartPage, StartPg
	mov		psh.pszCaption, offset WindowsPprt
	mov		psh.ppsp, offset psp1
	invoke	PropertySheet, addr psh
	ret

ShowWindowProperties endp


PropSheetProc proc hWnd:HWND, uMsg:UINT, lParam:LPARAM
	
	mov		edx, lParam
	.if uMsg==PSCB_PRECREATE
		xor		[edx+DLGTEMPLATE.style], DS_CONTEXTHELP
	.endif
	mov		eax, TRUE
	ret

PropSheetProc endp


InstallPlugins proc uses ebx esi lpHandleAddr:DWORD
	LOCAL 	wfd 		:WIN32_FIND_DATA
	LOCAL 	mii 		:MENUITEMINFO
	LOCAL	hFindFile	:DWORD
	LOCAL	hLibrary	:DWORD
	LOCAL	PlugText	:DWORD
	
	
	invoke	GetModuleFileName, hInstance, addr TextBuff, 256
	invoke	GetFilePath, addr PluginsDir, addr TextBuff
	invoke	lstrcat, addr PluginsDir, addr PluginsDirNm
	invoke	lstrcpy, addr PluginsDirSrch, addr PluginsDir
	invoke	lstrcat, addr PluginsDirSrch, addr DllFileNm

	mov		eax, offset PluginsDir
	mov		edx, offset PluginsDirSrch
	
	invoke	SetCurrentDirectory, addr PluginsDir
	xor		ebx, ebx
	.repeat 
		invoke	RemoveMenu, hPluginsMenu, ebx, MF_BYPOSITION
	.until eax==0
	
	mov		mii.cbSize, sizeof MENUITEMINFO
	mov		mii.fMask, MIIM_DATA or MIIM_ID	or MIIM_TYPE
	
	mov		ebx, ID_PLUGINS
	invoke	FindFirstFile, addr PluginsDirSrch, addr wfd
	.if eax!=INVALID_HANDLE_VALUE
		mov		hFindFile, eax
		.repeat
			invoke	wsprintf, addr TextBuff, addr PluginsFileFmt, addr PluginsDir, addr wfd.cFileName
			invoke	LoadLibrary, addr TextBuff
			.if eax!=0
				mov		hLibrary, eax
				invoke	GetProcAddress, eax, addr LoadPlugin
				.if eax!=0
					call	eax
					mov		mii.dwTypeData, eax
					invoke	GetProcAddress, hLibrary, addr ExecutePlugin
					.if eax!=0
						mov		mii.dwItemData, eax
						mov		mii.wID, ebx
						mov		mii.cch, 30
						mov		mii.fType, MFT_STRING
						invoke	InsertMenuItem, hPluginsMenu, 0, TRUE, addr mii
						inc		ebx
					.endif
				.endif
			.endif
			invoke	FindNextFile, hFindFile, addr wfd
		.until eax==0
	.endif
	ret

InstallPlugins endp


SendTextFromFile proc hWnd:HWND, FileName:DWORD
	LOCAL	hFile			 :DWORD
	LOCAL	TempMemory		 :DWORD
	LOCAL	FileSize		 :DWORD
	LOCAL	SizeReadWrite	 :DWORD

	invoke	CreateFile, FileName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, NULL, NULL
	.if eax!=INVALID_HANDLE_VALUE
		mov		hFile, eax
		invoke	GetFileSize, eax, NULL
		.if eax!=0
			mov		FileSize, eax
			add		eax, 12
			invoke	GlobalAlloc, GPTR, eax
			mov		TempMemory, eax
			invoke	ReadFile, hFile, TempMemory, FileSize, addr SizeReadWrite, NULL
			invoke	SendMessage, hWndWindow, WM_SETTEXT, 0, TempMemory
			invoke	GlobalFree, TempMemory
		.endif
		invoke	CloseHandle, hFile
	.endif
	ret

SendTextFromFile endp


SetWindowTransparent proc uses ebx hWnd:HWND, trnsValue:DWORD;, strt:DWORD
	
	.if trnsValue!=255
		invoke	LoadLibrary, addr User32Dll
		invoke	GetProcAddress, eax, addr SetTransProcAddr
		.if eax!=0
			mov		ebx, eax
			invoke	GetWindowLong, hWnd, GWL_EXSTYLE
			or		eax, 80000h
			invoke	SetWindowLong, hWnd, GWL_EXSTYLE, eax
			push	2
			push	trnsValue
			push	0
			push	hWnd
			call	ebx
			invoke	FreeLibrary, ebx 
		.endif
	.else
		invoke	GetWindowLong, hWnd, GWL_EXSTYLE
		test	eax, 080000h
		.if !(SIGN?)
			xor		eax, 80000h
			invoke	SetWindowLong, hWnd, GWL_EXSTYLE, eax
		.endif
	.endif
	ret

SetWindowTransparent endp


GetWindowTransparent proc uses ebx hWnd:HWND
	LOCAL	pbAlpha		:BYTE
	
	mov		pbAlpha, 0
	invoke	LoadLibrary, addr User32Dll
	invoke	GetProcAddress, eax, addr GetTransProcAddr
	.if eax!=0
		mov		ebx, eax
		push	0
		lea		eax, pbAlpha
		push	eax
		push	0
		push	hWnd
		call	ebx
		invoke	FreeLibrary, ebx 
	.endif
	movzx	eax, pbAlpha
	ret

GetWindowTransparent endp


GethWndDlgFromChild proc hWnd:DWORD
	LOCAL	hWndParent		:DWORD
	
	mov		eax, hWnd
	.repeat
		mov		hWndParent, eax
		invoke	GetWindowLong, hWndParent, GWL_STYLE
		.if !(eax & WS_CHILD)
			mov		eax, hWndParent
			ret
		.endif
		invoke	GetParent, hWndParent
	.until eax==0
	xor		eax, eax
	ret

GethWndDlgFromChild endp


GetFilePath proc uses ebx esi Output:DWORD, FullPathName:DWORD

	invoke	szCopy, FullPathName, Output
	invoke	szLen, Output
	dec		eax
	mov		edx, Output
	add		edx, eax
	.while byte ptr [edx]!='\'
		dec		edx
	.endw
	inc		edx
	mov		byte ptr [edx], 0
	ret

GetFilePath endp


dw2bin proc uses edi dwValue:DWORD,lpBuffer:DWORD
	
	mov		edi, lpBuffer
	mov		eax, dwValue
	mov		byte ptr [edi+32], 0
	mov		ecx, 31
	.repeat
		ror		eax, 1
		setc	dl
		or		dl, 30h
		mov		byte ptr [edi+ecx], dl
		dec		ecx
	.until SIGN?
	ret

dw2bin endp



ShowWindowError proc hWnd:HWND
	
	invoke	wsprintf, addr TextBuff, addr WinErrFmt, hWndWindow
	invoke	MessageBox, hWnd, addr TextBuff, addr Error, MB_ICONERROR
	ret

ShowWindowError endp


GetSystemOwner proc lpDest:DWORD, PlatformId:DWORD
	LOCAL	hKey		:DWORD
	LOCAL	lpdwDisp	:DWORD
	LOCAL	lpcbData	:DWORD
	LOCAL	lpType		:DWORD

	.if PlatformId==0
		invoke	RegCreateKeyEx, HKEY_LOCAL_MACHINE, addr OwnerKey, 0, addr REGSZ, 0, KEY_READ, 0, addr hKey, addr lpdwDisp
	.else
		invoke	RegCreateKeyEx, HKEY_LOCAL_MACHINE, addr OwnerKeyNT, 0, addr REGSZ, 0, KEY_READ, 0, addr hKey, addr lpdwDisp
	.endif
	.if eax==ERROR_SUCCESS
		mov     lpcbData, 250
		invoke	RegQueryValueEx, hKey, addr OwnerValName, 0, addr REGSZ, lpDest, addr lpcbData
		push	eax
		invoke	RegCloseKey, hKey
		pop		eax
	.endif	
	ret

GetSystemOwner endp 


EnableDlgWindow proc hDlg:HWND, nIDButton:DWORD, bEnable:DWORD
	
	invoke	GetDlgItem, hDlg, nIDButton
	invoke	EnableWindow, eax, bEnable
	ret

EnableDlgWindow endp


SaveSettings proc hWnd:HWND
	LOCAL	hKey		:DWORD
	LOCAL	lpType		:DWORD
	LOCAL	lpcbData	:DWORD
	LOCAL	lpdwDisp	:DWORD

	invoke	RegCreateKeyEx, HKEY_CURRENT_USER, addr szSettingsKey, 0, addr REGSZ, 0, KEY_WRITE or KEY_READ, 0, addr hKey, addr lpdwDisp
	.if eax==ERROR_SUCCESS
		push	SettingsLen
		pop		lpcbData
		invoke	RegSetValueEx, hKey, addr szSettings, 0, REG_BINARY, addr SettingStart, lpcbData
		invoke	RegCloseKey, hKey	
	.endif
	ret
	
SaveSettings endp


LoadSettings proc hWnd:HWND
	LOCAL	hKey		:DWORD
	LOCAL	lpType		:DWORD
	LOCAL	lpcbData	:DWORD
	LOCAL	lpdwDisp	:DWORD

	invoke	RegCreateKeyEx, HKEY_CURRENT_USER, addr szSettingsKey, 0, addr REGSZ, 0, KEY_WRITE or KEY_READ, 0, addr hKey, addr lpdwDisp
	.if eax==ERROR_SUCCESS
		push	SettingsLen
		pop		lpcbData
		invoke	RegQueryValueEx, hKey, addr szSettings, 0, addr lpType, addr TextBuff, addr lpcbData
		.if eax==ERROR_SUCCESS
			mov		eax, lpcbData
			.if eax==SettingsLen
				invoke	MemCopy, addr TextBuff, addr SettingStart, eax
			.endif
		.endif
		invoke	RegCloseKey, hKey
	.endif
	ret
	
LoadSettings endp



