;=================================================================
; Project Name	: Window Hack
; Version		: 3.0
; Compiler		: Masm32 v6.14 Microsoft Macro Assembler
; IDE			: RadAsm v2.2.1.0
; Tested		: Win98, XP
; Date			: 15-08-2006 --> 21-12-2006
; By			: Rudy Rooroh
;=================================================================


.386
.model flat,stdcall
option casemap:none

include WindowHack.inc
include Styles.inc
include Protos.inc
include Equates.inc


.code

include	Procedures.asm
include	WindowStyle.asm

start:

	invoke	GetModuleHandle, NULL
	mov		hInstance, eax
	invoke	GetCommandLine
	mov		CommandLine, eax
	mov		icex.dwSize, sizeof INITCOMMONCONTROLSEX
	mov		icex.dwICC, ICC_COOL_CLASSES or ICC_BAR_CLASSES or ICC_USEREX_CLASSES
	invoke	InitCommonControlsEx, addr icex
	invoke	FindWindow, addr ClassName, 0
	.if eax==0
		invoke	WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT
	.endif
	invoke	ExitProcess, eax


WinMain proc hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
	LOCAL	wc	:WNDCLASSEX
	LOCAL	msg	:MSG

	mov		wc.cbSize, sizeof WNDCLASSEX
	mov		wc.style, CS_HREDRAW or CS_VREDRAW
	mov		wc.lpfnWndProc, offset WndProc
	mov		wc.cbClsExtra, 4
	mov		wc.cbWndExtra, DLGWINDOWEXTRA
	push	hInst
	pop		wc.hInstance
	mov		wc.hbrBackground, COLOR_BTNFACE+1
	mov		wc.lpszMenuName, 0
	mov		wc.lpszClassName, offset ClassName
	invoke	LoadIcon, hInstance, IDR_MAINICON
	mov		wc.hIcon, 0
	mov		wc.hIconSm, eax
	invoke	LoadCursor, NULL, IDC_ARROW
	mov		wc.hCursor,eax
	invoke	RegisterClassEx, addr wc
	invoke	CreateDialogParam, hInstance, IDD_MAINDIALOG, NULL, addr WndProc, NULL
	invoke	ShowWindow, hWndMain, SW_SHOWNORMAL
	invoke	UpdateWindow, hWndMain
	.while TRUE
		invoke	GetMessage, addr msg, NULL, 0, 0
		.BREAK .if !eax
		invoke	TranslateMessage, addr msg
		invoke	DispatchMessage, addr msg
	.endw
	mov		eax, msg.wParam
	ret

WinMain endp


WndProc proc uses ebx hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL	lpProcessId		:DWORD
	LOCAL	rbbi			:REBARBANDINFO
	LOCAL	rect			:RECT
	LOCAL 	mii 			:MENUITEMINFO
	LOCAL 	osv 			:OSVERSIONINFO
	LOCAL 	hWndTemp 		:DWORD	
	

	.if uMsg==WM_INITDIALOG
		
		m2m		hWndMain, hWnd
		
		invoke	LoadSettings, 0
		
		mov     osv.dwOSVersionInfoSize, sizeof OSVERSIONINFO
		invoke	GetVersionEx, addr osv
		.if osv.dwPlatformId==VER_PLATFORM_WIN32_NT
			mov		NTPlatformId, 1
		.else
			mov		NTPlatformId, 0
		.endif
		
		invoke	LoadMenu, hInstance, IDM_MENU
		mov		hMenuMain, eax
		invoke	GetSubMenu, eax, 0
		mov		hActionMenu, eax
		invoke	GetSubMenu, hMenuMain, 1
		mov		hPluginsMenu, eax
		
		invoke	InstallPlugins, 0
		
		invoke	GetDlgItem, hWnd, IDC_MAINTBR
		mov		hToolbar, eax	
		invoke	SendMessage, eax, TB_SETEXTENDEDSTYLE, 0, TBSTYLE_EX_DRAWDDARROWS
		invoke	LoadBitmap, hInstance, IDR_TBRIMAGE
		invoke	DoToolBar, hToolbar, eax, ntbrbtns, addr tbrbtns
		
		invoke	GetDlgItem, hWnd, IDC_REBAR
		mov		hRebar, eax
		mov		rbbi.cbSize, sizeof REBARBANDINFO
		mov		rbbi.fMask, RBBIM_STYLE or RBBIM_CHILD or RBBIM_SIZE or RBBIM_CHILDSIZE ;or RBBIM_COLORS
		mov		rbbi.fStyle, RBBS_CHILDEDGE or RBBS_GRIPPERALWAYS
		push	hToolbar 
		pop		rbbi.hwndChild
		mov		rbbi.lx, 0
		mov		rbbi.cyMinChild, 22
		mov		rbbi.cxMinChild, 200
		invoke	SendMessage, hRebar, RB_INSERTBAND, 0, addr rbbi
		
		invoke	LoadCursor, hInstance, IDR_HANDCUR
		mov		hHandCursor, eax
		
		invoke	GetDesktopWindow
		mov		hWndDesktop, eax
		mov		hWndWindow, eax
		invoke	ShowWindowInformations, hWnd, hWndWindow
		
		invoke	SendDlgItemMessage, hWnd, IDC_FOCUSCBO, CB_ADDSTRING, 0, addr cbNormal
		invoke	SendDlgItemMessage, hWnd, IDC_FOCUSCBO, CB_ADDSTRING, 0, addr cbFocusRect
		invoke	SendDlgItemMessage, hWnd, IDC_FOCUSCBO, CB_ADDSTRING, 0, addr cbFocusBlock
		invoke	SendDlgItemMessage, hWnd, IDC_FOCUSCBO, CB_SETCURSEL, WindowFocus, 0
		
		
	.elseif uMsg==WM_LBUTTONUP
		
		invoke	PostMessage, hWnd, WM_STOPGETWNDHANDLE, 0, TRUE  
		invoke	ReleaseCapture
		
	.elseif uMsg==WM_RBUTTONDOWN
		
		invoke	PostMessage, hWnd, WM_STOPGETWNDHANDLE, 0, 0  
		invoke	ReleaseCapture
		
	.elseif uMsg==WM_COMMAND
		
		mov		eax, wParam
		mov		edx, eax
		and		eax, 0ffffh
		shr		edx, 16
		
		.if edx==BN_CLICKED
			
			.if eax==IDT_GETWNDUNDERCUR
				
				m2m		hWndWindowSave, hWndWindow
				invoke	GetWindowRect, hWnd, addr rect
				add		rect.top, 40
				add		rect.left, 4
				invoke	mouse_event, MOUSEEVENTF_ABSOLUTE or MOUSEEVENTF_LEFTDOWN, rect.left, rect.top, 0, 0
				.if WindowFocus!=0
					invoke	ShowWindow, hWnd, SW_MINIMIZE
					invoke	Sleep, 100
				.else
					invoke	SendMessage, hToolbar, WM_PAINT, 0, 0
				.endif
				invoke	SetCursor, hHandCursor
				invoke	SetCapture, hWnd
				invoke	CaptureDesktop, hWnd
				invoke	SetTimer, hWnd, ID_WINDOWMARKTIMER, 5, NULL
				mov		WindowMarkTimerID, eax
				
			.elseif eax==IDT_GETWNDFRLIST
				
				invoke	DialogBoxParam, hInstance, IDD_WINDOWSDLG, hWnd, addr WindowsDlg, NULL
				.if eax!=0
					mov		hWndWindow, eax
					invoke	ShowWindowInformations, hWnd, hWndWindow
				.endif
				
			.elseif eax==IDT_GETCHILDWNDFRLIST
				
				invoke	IsWindow, hWndWindow
				.if eax!=0
					invoke	DialogBoxParam, hInstance, IDD_WINDOWSDLG, hWnd, addr WindowsDlg, TRUE
					.if eax!=0
						mov		hWndWindow, eax
						invoke	ShowWindowInformations, hWnd, hWndWindow
					.endif
				.else
					invoke	ShowWindowError, hWnd	
				.endif
				
			.elseif eax==IDT_PARENTWINDOW
				
				invoke	IsWindow, hWndWindow
				.if eax!=0
					invoke	GetParent, hWndWindow
					.if eax!=0
						mov		hWndWindow, eax
						invoke	ShowWindowInformations, hWnd, hWndWindow
					.endif
				.else
					invoke	ShowWindowError, hWnd	
				.endif
				
			.elseif eax==IDT_CHILDWINDOW
				
				invoke	IsWindow, hWndWindow
				.if eax!=0
					invoke	GetWindow, hWndWindow, GW_CHILD
					.if eax!=0
						mov		hWndWindow, eax
						invoke	ShowWindowInformations, hWnd, hWndWindow
					.endif
				.else
					invoke	ShowWindowError, hWnd	
				.endif
				
			.elseif eax==IDT_NEXTWINDOW
				
				invoke	IsWindow, hWndWindow
				.if eax!=0
					invoke	GetWindow, hWndWindow, GW_HWNDNEXT
					.if eax!=0
						mov		hWndWindow, eax
						invoke	ShowWindowInformations, hWnd, hWndWindow
					.endif
				.else
					invoke	ShowWindowError, hWnd	
				.endif
				
			.elseif eax==IDT_PREVIOUSWINDOW
				
				invoke	IsWindow, hWndWindow
				.if eax!=0
					invoke	GetWindow, hWndWindow, GW_HWNDPREV
					.if eax!=0
						mov		hWndWindow, eax
						invoke	ShowWindowInformations, hWnd, hWndWindow
					.endif
				.else
					invoke	ShowWindowError, hWnd	
				.endif
				
			.elseif eax==IDT_ACTION
				
				mov		eax, LastActionCmd
				.if eax==0
					mov		eax, offset Action_Click
				.endif
				jmp		eax
				
			.elseif eax==IDT_WNDPROPERTIES
				
				invoke	IsWindow, hWndWindow
				.if eax!=0
					invoke	ShowWindowProperties, hWnd, 0
				.else
					invoke	ShowWindowError, hWnd	
				.endif
				
			.elseif eax==IDT_ABOUT
				
				invoke	DialogBoxParam, hInstance, IDD_ABOUTDLG, hWnd, addr AboutDlg, 0
				
			.elseif eax==IDT_EXIT || eax==IDCANCEL
				
				invoke	SendMessage, hWnd, WM_CLOSE, 0, 0
				
			.elseif eax==IDM_ACLICK
				
				Action_Click:
				
				invoke	SetFocus, hWndWindow
				invoke	PostMessage, hWndWindow, BM_CLICK, 0, 0
				mov		LastActionCmd, offset Action_Click
				
			.elseif eax==IDM_ADESTROY
				
				Action_Destroy:
				
				invoke	PostMessage, hWndWindow, WM_CLOSE, 0, 0
				mov		LastActionCmd, offset Action_Destroy
				
			.elseif eax==IDM_AKILLPROCESS
				
				Action_KillProcess:
				
				invoke	GetWindowThreadProcessId, hWndWindow, addr lpProcessId
				invoke	OpenProcess, PROCESS_TERMINATE, FALSE, lpProcessId
				invoke	TerminateProcess, eax, 0
				mov		LastActionCmd, offset Action_KillProcess
				
			.elseif eax==IDM_AFLASHWINDOW
				
				Action_FlashWindow:
				invoke	WindowFlash, hWnd
				mov		LastActionCmd, offset Action_FlashWindow
				
			.elseif eax==IDM_ASETWNDPOS
				
				Action_SetWindowPos:
				
				invoke	DialogBoxParam, hInstance, IDD_SETWNDPOSDLG, hWnd, addr SetWindowPosDlg, NULL
				mov		LastActionCmd, offset Action_SetWindowPos
				
			.elseif eax==IDM_ATRANSPARENT
				
				Action_Transparent:
				
				invoke	GethWndDlgFromChild, hWndWindow
				.if eax!=0
					invoke	DialogBoxParam, hInstance, IDD_TRANSPARENTDLG, hWnd, addr TransparentDlg, eax
					mov		LastActionCmd, offset Action_Transparent
				.else
					invoke	MessageBox, hWnd, addr ChildMsgErr, addr Error, MB_ICONERROR
				.endif
				
			.elseif eax==IDM_ASENDTEXT
				
				Action_SendText:
				
				invoke	DialogBoxParam, hInstance, IDD_SENDTEXTDLG, hWnd, addr SendTextDlg, NULL
				mov		LastActionCmd, offset Action_SendText
				
			.elseif eax==IDM_ASENDMSG
				
				Action_SendMessage:
				
				invoke	DialogBoxParam, hInstance, IDD_SENDMESSAGEDLG, hWnd, addr SendMessageDlg, NULL
				mov		LastActionCmd, offset Action_SendMessage
				
			.elseif eax==IDM_AENABLE
				
				Action_Enable:
				
				invoke	IsWindowEnabled, hWndWindow
				xor		eax, TRUE
				invoke	EnableWindow, hWndWindow, eax
				mov		LastActionCmd, offset Action_Enable
				
			.elseif eax==IDM_ACHECK
				
				Action_Check:
				
				invoke	SendMessage, hWndWindow, BM_GETCHECK, 0, 0
				xor		eax, TRUE
				invoke	SendMessage, hWndWindow, BM_SETCHECK, eax, 0
				mov		LastActionCmd, offset Action_Check
				
			.elseif eax==IDM_AHIDE
				
				Action_Hide:
				
				invoke	IsWindowVisible, hWndWindow
				xor		eax, TRUE
				invoke	ShowWindow, hWndWindow, eax
				mov		LastActionCmd, offset Action_Hide
				
			.elseif eax==IDM_ATOPMOST
				
				Action_TopMost:
				
				invoke	GetWindowRect, hWndWindow, addr rect
				invoke	GetWindowLong, hWndWindow, GWL_EXSTYLE
				test	eax, WS_EX_TOPMOST
				.if !(ZERO?)
					mov		eax, HWND_NOTOPMOST
				.else
					mov		eax, HWND_TOPMOST
				.endif
				mov		ecx, rect.right
				sub		ecx, rect.left
				mov		edx, rect.bottom
				sub		edx, rect.top
				invoke	SetWindowPos, hWndWindow, eax, rect.left, rect.top, ecx, edx, 0
				mov		LastActionCmd, offset Action_TopMost
				
			.elseif eax==IDM_AREADONLY
				
				Action_ReadOnly:
				
				invoke	GetWindowLong, hWndWindow, GWL_STYLE
				test	eax, ES_READONLY
				.if !(ZERO?)
					xor		eax, eax
				.else
					mov		eax, TRUE
				.endif
				invoke	SendMessage, hWndWindow, EM_SETREADONLY, eax, 0
				mov		LastActionCmd, offset Action_ReadOnly
				
			.elseif eax==IDM_ASTATENORMAL
				
				Action_Normal:
				invoke	ShowWindow, hWndWindow, SW_RESTORE
				mov		LastActionCmd, offset Action_Normal
				
			.elseif eax==IDM_ASTATEMAX
				
				Action_Maximized:
				invoke	ShowWindow, hWndWindow, SW_MAXIMIZE
				mov		LastActionCmd, offset Action_Maximized
				
			.elseif eax==IDM_ASTATEMIN
				
				Action_Minimized:
				invoke	ShowWindow, hWndWindow, SW_MINIMIZE
				mov		LastActionCmd, offset Action_Minimized
				
			.elseif eax>=800 && eax<=899
				
				mov		mii.cbSize, sizeof MENUITEMINFO
				mov		mii.fMask, MIIM_DATA or MIIM_ID
				mov		mii.wID, eax
				invoke	GetMenuItemInfo, hPluginsMenu, mii.wID, FALSE, addr mii
				mov		eax, mii.dwItemData
				push	hWndWindow
				push	hWnd
				call	eax
				
			.endif
			
		.elseif edx==CBN_SELCHANGE
			
			.if eax==IDC_FOCUSCBO
				invoke	SendDlgItemMessage, hWnd, IDC_FOCUSCBO, CB_GETCURSEL, 0, 0
				mov		WindowFocus, eax
				invoke	SaveSettings, 0
			.endif
			
		.endif
		
	.elseif uMsg==WM_TIMER
		
		mov		eax, wParam
		
		.if eax==ID_WINDOWMARKTIMER
			
			invoke	GetWindowDC, hWndDesktop
			mov		hWndDesktopDC, eax
			invoke	ChildWindowUnderCursor
			mov		hWndTemp, eax
			invoke	GethWndDlgFromChild, eax
			.if eax!=hWnd
				m2m		hWndWindow, hWndTemp
				.if WindowFocus!=0
					invoke	PaintWindowMark, hWndWindow
				.else
					invoke	ShowWindowInformations, hWnd, hWndWindow
				.endif
			.endif
			
		.endif
		
	.elseif uMsg==WM_STOPGETWNDHANDLE
		
		invoke	KillTimer, hWnd, WindowMarkTimerID
		invoke	SendMessage, hWndFakeWindow, WM_CLOSE, 0, 0
		.if WindowFocus!=0
			invoke	PaintDesktopCapture
		.endif
		invoke	FreeCaptureDesktop
		invoke	SendMessage, hToolbar, WM_PAINT, 0, 0
		invoke	ShowWindow, hWnd, SW_SHOWDEFAULT
		.if lParam!=TRUE
			m2m		hWndWindow, hWndWindowSave
		.endif
		invoke	ShowWindowInformations, hWnd, hWndWindow
		
	.elseif uMsg==WM_NOTIFY
		
		mov 	ebx, lParam
		
		.if [ebx+NMHDR.code]==TBN_DROPDOWN
			
			mov		edx, [ebx+NMTOOLBAR.iItem]
			invoke	SendMessage, hToolbar, TB_GETRECT, edx, addr rect
			m2m		rect.top, rect.bottom
			invoke	ClientToScreen, hToolbar, addr rect
			mov		eax, [ebx+NMTOOLBAR.iItem]
			.if eax==IDT_ACTION
				invoke	InitActionMenu, hActionMenu, hWndWindow
				mov		ecx, hActionMenu
			.else
				mov		ecx, hPluginsMenu
			.endif
			invoke	TrackPopupMenu, ecx, TPM_LEFTALIGN or TPM_LEFTBUTTON, rect.left, rect.top, 0, hToolbar, 0
			
		.elseif [ebx+NMHDR.code]==TTN_NEEDTEXT
			
			mov		eax, [ebx+NMHDR.idFrom]
			sub		eax, IDT_GETWNDUNDERCUR
			mov		edx, offset TbrTooltipArr
			mov		ecx,  dword ptr [edx+eax*4]
			mov		[ebx+TOOLTIPTEXT.lpszText], ecx 
			
		.endif
		
	.elseif uMsg==WM_CLOSE
		
		invoke	DestroyWindow, hWnd
		
	.elseif uMsg==WM_DESTROY
		
		invoke	PostQuitMessage, NULL
		
	.else
		
		invoke	DefWindowProc, hWnd, uMsg, wParam, lParam
		ret
		
	.endif

	xor    eax,eax
	ret

WndProc endp


WindowsDlg proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL	hImageList	:DWORD
	LOCAL	hTrvBmp		:DWORD
	LOCAL	pt			:POINT
	LOCAL	rect		:RECT
	LOCAL	tvi			:TV_ITEM
	LOCAL	tvhti		:TV_HITTESTINFO
	
	.if uMsg==WM_INITDIALOG
		
		invoke	LoadIcon, hInstance, IDR_WNDICON
		invoke	SendMessage, hWnd, WM_SETICON, ICON_SMALL, eax
		
		invoke	GetSubMenu, hMenuMain, 2
		mov		hWindowsMenu, eax
		
		invoke	LoadBitmap, hInstance, IDR_TBRIMAGE
		mov		hTrvBmp, eax
		invoke	ImageList_Create, 16, 16, ILC_MASK or ILC_COLORDDB, 20, 20 
		mov		hImageList, eax
		invoke	ImageList_AddMasked, hImageList, hTrvBmp, 00FF00FFh
		invoke	SendDlgItemMessage, hWnd, IDC_WINDOWSTRV, TVM_SETIMAGELIST, 0, hImageList
		invoke	DeleteObject, hTrvBmp
		
		mov		CurrentItem, 0
		invoke	SendDlgItemMessage, hWnd, IDC_WINDOWSTRV, TVM_DELETEITEM, 0, TVI_ROOT
		.if lParam==0
			invoke	GetAllWindows, hWnd, 0, hWndWindow, 0
		.else
			.if hWndWindow!=0
				invoke	GetChildWindows, hWnd, hWndWindow
			.else
				invoke	GetAllWindows, hWnd, 0, hWndWindow, 0
			.endif
		.endif
		invoke	SendDlgItemMessage, hWnd, IDC_WINDOWSTRV, TVM_EXPAND, TVE_EXPAND, eax
		invoke	SendDlgItemMessage, hWnd, IDC_WINDOWSTRV, TVM_SELECTITEM, TVGN_CARET, CurrentItem
		
		
	.elseif uMsg==WM_COMMAND
		
		mov		eax, wParam
		mov		edx, eax
		and		eax, 0ffffh
		shr		edx, 16
		
		.if eax==IDM_GETWINDOW
			
			invoke	SendDlgItemMessage, hWnd, IDC_WINDOWSTRV, TVM_GETNEXTITEM, TVGN_CARET, 0
			mov		tvi.hItem, eax
			mov		tvi._mask, TVIF_PARAM or TVIF_HANDLE
			invoke	SendDlgItemMessage, hWnd, IDC_WINDOWSTRV, TVM_GETITEM, 0, addr tvi 
			mov		eax, tvi.lParam 
			invoke	EndDialog, hWnd, eax
			
		.elseif eax==IDM_REFRESHWND
			
			invoke	SendDlgItemMessage, hWnd, IDC_WINDOWSTRV, TVM_GETNEXTITEM, TVGN_ROOT, 0
			mov		tvi.hItem, eax
			mov		tvi._mask, TVIF_PARAM or TVIF_HANDLE
			invoke	SendDlgItemMessage, hWnd, IDC_WINDOWSTRV, TVM_GETITEM, 0, addr tvi 
			mov		eax, tvi.lParam 
			.if eax==hWndDesktop
				push	FALSE
			.else
				push	TRUE
			.endif
			invoke	SendDlgItemMessage, hWnd, IDC_WINDOWSTRV, TVM_DELETEITEM, 0, TVI_ROOT
			pop		eax
			.if eax!=0
				invoke	GetChildWindows, hWnd, hWndWindow
			.else
				invoke	GetAllWindows, hWnd, 0, hWndWindow, 0
			.endif
			invoke	SendDlgItemMessage, hWnd, IDC_WINDOWSTRV, TVM_EXPAND, TVE_EXPAND, eax
			
		.elseif eax==IDM_EXPANDTREE
			
			invoke	ExpandTreeView, hWnd, 0, TVE_EXPAND
			
		.elseif eax==IDM_COLLAPSETREE
			
			invoke	ExpandTreeView, hWnd, 0, TVE_COLLAPSE
			
		.endif
		
	.elseif uMsg==WM_NOTIFY
		
		.if wParam==IDC_WINDOWSTRV
			
			mov 	edx, lParam
			
			.if [edx+NMHDR.code]==NM_RCLICK
				invoke	GetCursorPos, addr pt
				invoke	GetDlgItem, hWnd, IDC_WINDOWSTRV
				mov		edx, eax
				invoke	ScreenToClient, edx, addr pt
				mov		tvhti.flags, TVHT_ONITEM
				m2m		tvhti.pt.x, pt.x
				m2m		tvhti.pt.y, pt.y
				invoke	SendDlgItemMessage, hWnd, IDC_WINDOWSTRV, TVM_HITTEST, 0, addr tvhti
				mov		eax, tvhti.hItem
				invoke	SendDlgItemMessage, hWnd, IDC_WINDOWSTRV, TVM_SELECTITEM, TVGN_CARET, eax	
				invoke	GetCursorPos, addr pt
				invoke	TrackPopupMenu, hWindowsMenu, TPM_LEFTALIGN	or TPM_RIGHTBUTTON, pt.x, pt.y, 0, hWnd, 0
			.endif
			
		.endif
		
	.elseif uMsg==WM_SIZE
		
		invoke	GetDlgItem, hWnd, IDC_WINDOWSSTATUSBAR
		push	eax
		invoke	MoveWindow, eax, 0, 0, 0, 0, TRUE
		pop		edx
		invoke	GetWindowRect, edx, addr rect
		invoke	GetDlgItem, hWnd, IDC_WINDOWSTRV
		push	eax
		mov		ecx, lParam
		mov		edx, ecx
		and		ecx, 0ffffh
		shr		edx, 16		
		mov		eax, rect.bottom
		sub		eax, rect.top
		sub		edx, eax
		pop		eax
		invoke	MoveWindow, eax, 0, 0, ecx, edx, TRUE
		
	.elseif uMsg==WM_CLOSE
		
		invoke	EndDialog, hWnd, 0
		
	.else
		
		mov		eax, FALSE
		ret
		
	.endif
	
	mov		eax, TRUE
	ret

WindowsDlg endp


WndPprtGeneralDlg proc uses ebx hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL	hWndInstance	:DWORD
	LOCAL	cbWndExtra		:DWORD
	LOCAL	rect			:RECT
	LOCAL	wp				:WINDOWPLACEMENT
	
	
	.if uMsg==WM_INITDIALOG
		
		invoke	GetWindowText, hWndWindow, addr WindowName, 256
		invoke	SendDlgItemMessage, hWnd, IDC_WNDCAPTIONEDT, WM_SETTEXT, 0, addr WindowName
		
		invoke	wsprintf, addr TextBuff, addr HexFmt, hWndWindow
		invoke	SendDlgItemMessage, hWnd, IDC_WNDHANDLESTC, WM_SETTEXT, 0, addr TextBuff
		
		invoke	GetWindowLong, hWndWindow, GWL_WNDPROC
		invoke	wsprintf, addr TextBuff, addr HexFmt, eax
		invoke	SendDlgItemMessage, hWnd, IDC_WNDPROCSTC, WM_SETTEXT, 0, addr TextBuff
		
		invoke	GetWindowRect, hWndWindow, addr rect
		mov		ecx, rect.right
		sub		ecx, rect.left
		mov		edx, rect.bottom
		sub		edx, rect.top
		invoke	wsprintf, addr TextBuff, addr WindowRectFmt, rect.left, rect.top, rect.right, rect.bottom, ecx, edx
		invoke	SendDlgItemMessage, hWnd, IDC_WNDRECTSTC, WM_SETTEXT, 0, addr TextBuff
		
		mov		wp.iLength, sizeof WINDOWPLACEMENT
		invoke	GetWindowPlacement, hWndWindow, addr wp
		mov		ecx, wp.rcNormalPosition.right
		sub		ecx, wp.rcNormalPosition.left
		mov		edx, wp.rcNormalPosition.bottom
		sub		edx, wp.rcNormalPosition.top
		invoke	wsprintf, addr TextBuff, addr WindowRectFmt, wp.rcNormalPosition.left, wp.rcNormalPosition.top, wp.rcNormalPosition.right, wp.rcNormalPosition.bottom, ecx, edx
		invoke	SendDlgItemMessage, hWnd, IDC_WNDRESRECTSTC, WM_SETTEXT, 0, addr TextBuff
		
		invoke	GetClientRect, hWndWindow, addr rect
		mov		ecx, rect.right
		sub		ecx, rect.left
		mov		edx, rect.bottom
		sub		edx, rect.top
		invoke	wsprintf, addr TextBuff, addr WindowRectFmt, rect.left, rect.top, rect.right, rect.bottom, ecx, edx
		invoke	SendDlgItemMessage, hWnd, IDC_WNDCLIENTRECTSTC, WM_SETTEXT, 0, addr TextBuff
		
		invoke	GetWindowLong, hWndWindow, GWL_HINSTANCE
		mov		hWndInstance, eax
		invoke	wsprintf, addr TextBuff, addr HexFmt, eax
		invoke	SendDlgItemMessage, hWnd, IDC_WNDINSTANCESTC, WM_SETTEXT, 0, addr TextBuff
		
		invoke	GetMenu, hWndWindow
		invoke	wsprintf, addr TextBuff, addr HexFmt, eax
		invoke	SendDlgItemMessage, hWnd, IDC_WNDMENUHANDLESTC, WM_SETTEXT, 0, addr TextBuff
		
		invoke	GetWindowLong, hWndWindow, GWL_USERDATA
		invoke	wsprintf, addr TextBuff, addr HexFmt, eax
		invoke	SendDlgItemMessage, hWnd, IDC_WNDUSERDATASTC, WM_SETTEXT, 0, addr TextBuff
		
		invoke	GetClassLong, hWndWindow, GCL_CBWNDEXTRA
		.if eax!=0
			mov		cbWndExtra, eax
			xor		ebx, ebx
			.while cbWndExtra!=0
				mov		ecx, cbWndExtra
				.if ecx>=4
					sub		cbWndExtra, 4
					invoke	GetWindowLong, hWndWindow, ebx
					invoke	wsprintf, addr TextBuff, addr WndLongBytesFmt, ebx, eax
				.else
					sub		cbWndExtra, 2
					invoke	GetWindowWord, hWndWindow, ebx
					invoke	wsprintf, addr TextBuff, addr WndWordBytesFmt, ebx, eax
				.endif 
				invoke	SendDlgItemMessage, hWnd, IDC_WNDBYTESCBO, CB_ADDSTRING, 0, addr TextBuff
				add		ebx, 4
			.endw
			invoke	SendDlgItemMessage, hWnd, IDC_WNDBYTESCBO, CB_SETCURSEL, 0, 0
		.else
			invoke	GetDlgItem, hWnd, IDC_WNDBYTESCBO
			invoke	EnableWindow, eax, FALSE
		.endif
		
		
	.elseif uMsg==WM_CLOSE
		
		invoke	EndDialog, hWnd, 0
		
	.else
		
		mov		eax, FALSE
		ret
		
	.endif
	
	mov		eax, TRUE
	ret

WndPprtGeneralDlg endp


WndPprtStylesDlg proc uses ebx esi edi hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL	hWndStyles		:DWORD	
	LOCAL	hWndExStyles	:DWORD
	LOCAL	lpWndName		:DWORD
	LOCAL	Lastal			:DWORD

	
	.if uMsg==WM_INITDIALOG
		
		invoke	GetWindowLong, hWndWindow, GWL_STYLE
		mov		hWndStyles, eax
		invoke	wsprintf, addr TextBuff, addr HexFmt, eax
		invoke	SendDlgItemMessage, hWnd, IDC_WNDSTYLESSTC, WM_SETTEXT, 0, addr TextBuff
		
		invoke	dw2bin, hWndStyles, addr TextBuff
		invoke	SendDlgItemMessage, hWnd, IDC_WNDSTYLESEDT, WM_SETTEXT, 0, addr TextBuff
		
		invoke	FillWindowStyleName, hWnd, IDC_WNDSTYLESLST, hWndStyles
		
		.if !(hWndStyles & WS_CHILD)
			
			invoke	FillDialogStyleName, hWnd, IDC_WNDSTYLESLST, hWndStyles
			
		.else
			
			invoke	GetClassName, hWndWindow, addr TextBuff, 256
			invoke	lstrcmpi, addr TextBuff, addr BtnClass
			.if eax==0
				invoke	FillButtonStyleName, hWnd, IDC_WNDSTYLESLST, hWndStyles
				jmp		NextExtendedStyle
			.endif
			invoke	lstrcmpi, addr TextBuff, addr StcClass
			.if eax==0
				invoke	FillStaticStyleName, hWnd, IDC_WNDSTYLESLST, hWndStyles
				jmp		NextExtendedStyle
			.endif
			invoke	lstrcmpi, addr TextBuff, addr LBClass
			.if eax==0
				invoke	FillListBoxStyleName, hWnd, IDC_WNDSTYLESLST, hWndStyles
				jmp		NextExtendedStyle
			.endif
			invoke	lstrcmpi, addr TextBuff, addr CBClass
			.if eax==0
				invoke	FillComboBoxStyleName, hWnd, IDC_WNDSTYLESLST, hWndStyles
				jmp		NextExtendedStyle
			.endif
			invoke	lstrcmpi, addr TextBuff, addr EditClass
			.if eax==0
				invoke	FillEditStyleName, hWnd, IDC_WNDSTYLESLST, hWndStyles
				jmp		NextExtendedStyle
			.endif
			invoke	lstrcmpi, addr TextBuff, addr RichEditClass
			.if eax==0
				invoke	FillEditStyleName, hWnd, IDC_WNDSTYLESLST, hWndStyles
				jmp		NextExtendedStyle
			.endif
			invoke	lstrcmpi, addr TextBuff, addr RichEdit20Class
			.if eax==0
				invoke	FillEditStyleName, hWnd, IDC_WNDSTYLESLST, hWndStyles
				jmp		NextExtendedStyle
			.endif
			invoke	lstrcmpi, addr TextBuff, addr LV32Class
			.if eax==0
				invoke	FillListViewStyleName, hWnd, IDC_WNDSTYLESLST, hWndStyles
				jmp		NextExtendedStyle
			.endif
			invoke	lstrcmpi, addr TextBuff, addr TV32Class
			.if eax==0
				invoke	FillTreeViewStyleName, hWnd, IDC_WNDSTYLESLST, hWndStyles
				jmp		NextExtendedStyle
			.endif
			invoke	lstrcmpi, addr TextBuff, addr Tab32Class
			.if eax==0
				invoke	FillTabStyleName, hWnd, IDC_WNDSTYLESLST, hWndStyles
				jmp		NextExtendedStyle
			.endif
			invoke	lstrcmpi, addr TextBuff, addr Ani32Class
			.if eax==0
				invoke	FillAniStyleName, hWnd, IDC_WNDSTYLESLST, hWndStyles
				jmp		NextExtendedStyle
			.endif
			invoke	lstrcmpi, addr TextBuff, addr Dtp32Class
			.if eax==0
				invoke	FillDtpStyleName, hWnd, IDC_WNDSTYLESLST, hWndStyles
				jmp		NextExtendedStyle
			.endif
			invoke	lstrcmpi, addr TextBuff, addr PagerClass
			.if eax==0
				invoke	FillPagerStyleName, hWnd, IDC_WNDSTYLESLST, hWndStyles
				jmp		NextExtendedStyle
			.endif
			invoke	lstrcmpi, addr TextBuff, addr Trackbar32Class
			.if eax==0
				invoke	FillTrackBarStyleName, hWnd, IDC_WNDSTYLESLST, hWndStyles
				jmp		NextExtendedStyle
			.endif
			invoke	lstrcmpi, addr TextBuff, addr UpDown32Class
			.if eax==0
				invoke	FillUpDownStyleName, hWnd, IDC_WNDSTYLESLST, hWndStyles
				jmp		NextExtendedStyle
			.endif
			invoke	lstrcmpi, addr TextBuff, addr Rebar32Class
			.if eax==0
				invoke	FillRebarStyleName, hWnd, IDC_WNDSTYLESLST, hWndStyles
				jmp		NextExtendedStyle
			.endif
			invoke	lstrcmpi, addr TextBuff, addr Toolbar32Class
			.if eax==0
				invoke	FillToolbarStyleName, hWnd, IDC_WNDSTYLESLST, hWndStyles
				jmp		NextExtendedStyle
			.endif
			invoke	lstrcmpi, addr TextBuff, addr Header32Class
			.if eax==0
				invoke	FillHeaderStyleName, hWnd, IDC_WNDSTYLESLST, hWndStyles
				jmp		NextExtendedStyle
			.endif
			invoke	lstrcmpi, addr TextBuff, addr StatusBar32Class
			.if eax==0
				invoke	FillStatusBarStyleName, hWnd, IDC_WNDSTYLESLST, hWndStyles
				jmp		NextExtendedStyle
			.endif
			
			NextExtendedStyle:
			
		.endif
		
		invoke	GetWindowLong, hWndWindow, GWL_EXSTYLE
		mov		hWndExStyles, eax
		invoke	wsprintf, addr TextBuff, addr HexFmt, eax
		invoke	SendDlgItemMessage, hWnd, IDC_WNDEXTSTYLESSTC, WM_SETTEXT, 0, addr TextBuff
		
		invoke	dw2bin, hWndExStyles, addr TextBuff
		invoke	SendDlgItemMessage, hWnd, IDC_WNDEXTSTYLESEDT, WM_SETTEXT, 0, addr TextBuff
		
		invoke	FillExWindowStyleName, hWnd, IDC_WNDEXTSTYLESLST, hWndExStyles
		
	.elseif uMsg==WM_CLOSE
		
		invoke	EndDialog, hWnd, 0
		
	.else
		
		mov		eax, FALSE
		ret
		
	.endif
	
	mov		eax, TRUE
	ret

WndPprtStylesDlg endp


WndPprtWindowsDlg proc uses ebx hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL	hWndStatic	:HWND
	
	.if uMsg==WM_INITDIALOG
		
		invoke	GetWindow, hWndWindow, GW_HWNDNEXT
		.if eax!=0
			invoke	wsprintf, addr TextBuff, addr HexFmt, eax
			mov		eax, offset TextBuff
		.else
			mov		eax, offset None
		.endif
		invoke	SendDlgItemMessage, hWnd, IDC_WNDNEXTWINDOWSTC, WM_SETTEXT, 0, eax
		
		invoke	GetWindow, hWndWindow, GW_HWNDPREV
		.if eax!=0
			invoke	wsprintf, addr TextBuff, addr HexFmt, eax
			mov		eax, offset TextBuff
		.else
			mov		eax, offset None
		.endif
		invoke	SendDlgItemMessage, hWnd, IDC_WNDPREVIOUSWINDOWSTC, WM_SETTEXT, 0, eax
		
		invoke	GetWindowLong, hWndWindow, GWL_HWNDPARENT
		.if eax!=0
			invoke	wsprintf, addr TextBuff, addr HexFmt, eax
			mov		eax, offset TextBuff
		.else
			mov		eax, offset None
		.endif
		invoke	SendDlgItemMessage, hWnd, IDC_WNDPARENTWINDOWSTC, WM_SETTEXT, 0, eax
		
		invoke	GetWindow, hWndWindow, GW_CHILD
		.if eax!=0
			invoke	wsprintf, addr TextBuff, addr HexFmt, eax
			mov		eax, offset TextBuff
		.else
			mov		eax, offset None
		.endif
		invoke	SendDlgItemMessage, hWnd, IDC_WNDFIRSTCHILDSTC, WM_SETTEXT, 0, eax
		
		invoke	GetWindow, hWndWindow, GW_OWNER
		.if eax!=0
			invoke	wsprintf, addr TextBuff, addr HexFmt, eax
			mov		eax, offset TextBuff
		.else
			mov		eax, offset None
		.endif
		invoke	SendDlgItemMessage, hWnd, IDC_WNDOWNERWINDOWSTC, WM_SETTEXT, 0, eax
		
		
	.elseif uMsg==WM_NOTIFY
		
		mov		edx, lParam
		.if [edx+NMHDR.code]==PSN_APPLY
			
		.endif
		
	.elseif uMsg==WM_CLOSE
		
		invoke	EndDialog, hWnd, 0
		
	.else
		
		mov		eax, FALSE
		ret
		
	.endif
	
	mov		eax, TRUE
	ret

WndPprtWindowsDlg endp


WndPprtClassDlg proc uses ebx hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL	sCount		:DWORD
	LOCAL	ClassStyles	:DWORD
	LOCAL	cbClsExtra	:DWORD
	
	
	.if uMsg==WM_INITDIALOG
		
		invoke	GetClassName, hWndWindow, addr ClassNm, 256
		invoke	SendDlgItemMessage, hWnd, IDC_WNDCLASSNAMEEDT, WM_SETTEXT, 0, addr ClassNm
		
		invoke	GetClassLong, hWndWindow, GCL_STYLE
		mov		ClassStyles, eax
		invoke	wsprintf, addr TextBuff, addr HexFmt, eax
		invoke	SendDlgItemMessage, hWnd, IDC_WNDCLASSSTYLESSTC, WM_SETTEXT, 0, addr TextBuff
		
		.if ClassStyles!=0
			mov		sCount, 13
			xor		ebx, ebx
			.while ebx!=sCount
				mov		eax, dword ptr [ClassStyleValAddr+ebx*4]
				.if ClassStyles & eax
					mov		eax, dword ptr [ClassStyleTxtAddr+ebx*4]
					invoke	SendDlgItemMessage, hWnd, IDC_WNDCLASSSTYLESCBO, CB_ADDSTRING, 0, eax
				.endif
				inc		ebx
			.endw
			invoke	SendDlgItemMessage, hWnd, IDC_WNDCLASSSTYLESCBO, CB_SETCURSEL, 0, 0
		.else
			invoke	GetDlgItem, hWnd, IDC_WNDCLASSSTYLESCBO
			invoke	EnableWindow, eax, FALSE			
		.endif
		
		invoke	GetClassLong, hWndWindow, GCL_CBCLSEXTRA
		mov		cbClsExtra, eax
		invoke	wsprintf, addr TextBuff, addr HexShortFmt, eax
		invoke	SendDlgItemMessage, hWnd, IDC_WNDCLASSBYTESSTC, WM_SETTEXT, 0, addr TextBuff
		.if cbClsExtra!=0
			xor		ebx, ebx
			.while cbClsExtra!=0
				mov		ecx, cbClsExtra
				.if ecx>=4
					sub		cbClsExtra, 4
					invoke	GetClassLong, hWndWindow, ebx
					invoke	wsprintf, addr TextBuff, addr WndLongBytesFmt, ebx, eax
				.else
					sub		cbClsExtra, 2
					invoke	GetClassWord, hWndWindow, ebx
					invoke	wsprintf, addr TextBuff, addr WndWordBytesFmt, ebx, eax
				.endif 
				invoke	SendDlgItemMessage, hWnd, IDC_WNDCLASSBYTESCBO, CB_ADDSTRING, 0, addr TextBuff
				add		ebx, 4
			.endw
			invoke	SendDlgItemMessage, hWnd, IDC_WNDCLASSBYTESCBO, CB_SETCURSEL, 0, 0
		.else
			invoke	GetDlgItem, hWnd, IDC_WNDCLASSBYTESCBO
			invoke	EnableWindow, eax, FALSE
		.endif
		
		invoke	GetClassLong, hWndWindow, GCW_ATOM
		invoke	wsprintf, addr TextBuff, addr HexShortFmt, eax
		invoke	SendDlgItemMessage, hWnd, IDC_WNDCLASSATOMSTC, WM_SETTEXT, 0, addr TextBuff
		
		invoke	GetClassLong, hWndWindow, GCL_CBWNDEXTRA 
		invoke	wsprintf, addr TextBuff, addr DecShortFmt, eax
		invoke	SendDlgItemMessage, hWnd, IDC_WNDWINDOWBYTESSTC, WM_SETTEXT, 0, addr TextBuff
		
		invoke	GetClassLong, hWndWindow, GCL_MENUNAME
		.if eax!=0 
			invoke	wsprintf, addr TextBuff, addr HexFmt, eax
			mov		eax, offset TextBuff
		.else
			mov		eax, offset None
		.endif
		invoke	SendDlgItemMessage, hWnd, IDC_WNDMENUNAMESTC, WM_SETTEXT, 0, eax
		
		invoke	GetClassLong, hWndWindow, GCL_HICON
		.if eax!=0 
			push	eax
			invoke	SendDlgItemMessage, hWnd, IDC_WNDICONHANDLEIMG, STM_SETICON, eax, 0
			pop		eax
			invoke	wsprintf, addr TextBuff, addr HexFmt, eax
			mov		eax, offset TextBuff
		.else
			mov		eax, offset None
		.endif
		invoke	SendDlgItemMessage, hWnd, IDC_WNDICONHANDLESTC, WM_SETTEXT, 0, eax
		
		invoke	GetClassLong, hWndWindow, GCL_HCURSOR
		.if eax!=0 
			push	eax
			invoke	SendDlgItemMessage, hWnd, IDC_WNDCURSORHANDLEIMG, STM_SETICON, eax, 0
			pop		eax
			invoke	wsprintf, addr TextBuff, addr HexFmt, eax
			mov		eax, offset TextBuff
		.else
			mov		eax, offset None
		.endif
		invoke	SendDlgItemMessage, hWnd, IDC_WNDCURSORHANDLESTC, WM_SETTEXT, 0, eax
		
		invoke	GetClassLong, hWndWindow, GCL_HBRBACKGROUND
		.if eax!=0 
			invoke	wsprintf, addr TextBuff, addr HexFmt, eax
			mov		eax, offset TextBuff
		.else
			mov		eax, offset None
		.endif
		invoke	SendDlgItemMessage, hWnd, IDC_WNDBKGNDBRUSHSTC, WM_SETTEXT, 0, eax
		
		invoke	GetClassLong, hWndWindow, GCL_HMODULE
		.if eax!=0 
			invoke	wsprintf, addr TextBuff, addr HexFmt, eax
			mov		eax, offset TextBuff
		.else
			mov		eax, offset None
		.endif
		invoke	SendDlgItemMessage, hWnd, IDC_WNDINSTANCEHANDLESTC, WM_SETTEXT, 0, eax
		
		invoke	GetClassLong, hWndWindow, GCL_WNDPROC
		.if eax!=0 
			invoke	wsprintf, addr TextBuff, addr HexFmt, eax
			mov		eax, offset TextBuff
		.else
			mov		eax, offset None
		.endif
		invoke	SendDlgItemMessage, hWnd, IDC_WNDWINDOWPROCSTC, WM_SETTEXT, 0, eax
		
		
	.elseif uMsg==WM_CLOSE
		
		invoke	EndDialog, hWnd, 0
		
	.else
		
		mov		eax, FALSE
		ret
		
	.endif
	
	mov		eax, TRUE
	ret

WndPprtClassDlg endp


WndPprtProcessDlg proc uses ebx hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL	lpProcessId		:DWORD
	LOCAL	lpThreadId		:DWORD
	LOCAL	hSnapshot		:DWORD
	LOCAL	ModuleEntry		:MODULEENTRY32
	LOCAL	ProcessEntry	:PROCESSENTRY32
	
	.if uMsg==WM_INITDIALOG
		
		invoke	GetWindowThreadProcessId, hWndWindow, addr lpProcessId
		mov		lpThreadId, eax
		invoke	wsprintf, addr TextBuff, addr HexFmt, lpProcessId
		invoke	SendDlgItemMessage, hWnd, IDC_WNDPROCESIDSTC, WM_SETTEXT, 0, addr TextBuff
		
		invoke	GetDesktopWindow
		.if eax!=hWndWindow
			invoke	CreateToolhelp32Snapshot, TH32CS_SNAPALL, lpProcessId
			mov		hSnapshot, eax
			mov		ProcessEntry.dwSize, sizeof PROCESSENTRY32
			invoke	Process32First, hSnapshot, addr ProcessEntry
			mov		eax, ProcessEntry.th32ProcessID
			.while eax!=lpProcessId && eax!=0
				invoke	Process32Next, hSnapshot, addr ProcessEntry
				mov		eax, ProcessEntry.th32ProcessID
			.endw
			
			lea		eax, ProcessEntry.szExeFile
			invoke	SendDlgItemMessage, hWnd, IDC_WNDPROCESSNAMEEDT, WM_SETTEXT, 0, eax
			
			mov		eax, ProcessEntry.pcPriClassBase
			invoke	wsprintf, addr TextBuff, addr DecShortFmt, eax
			invoke	SendDlgItemMessage, hWnd, IDC_WNDPRIORITYBASESTC, WM_SETTEXT, 0, addr TextBuff
			
			mov		eax, ProcessEntry.th32ParentProcessID
			invoke	wsprintf, addr TextBuff, addr HexFmt, eax
			invoke	SendDlgItemMessage, hWnd, IDC_WNDPARENTPROCESSSTC, WM_SETTEXT, 0, addr TextBuff
			
			invoke	wsprintf, addr TextBuff, addr HexFmt, lpThreadId
			invoke	SendDlgItemMessage, hWnd, IDC_WNDTHREADIDSTC, WM_SETTEXT, 0, addr TextBuff
			
			mov		eax, ProcessEntry.cntThreads
			invoke	wsprintf, addr TextBuff, addr DecShortFmt, eax
			invoke	SendDlgItemMessage, hWnd, IDC_WNDTHREADSSTC, WM_SETTEXT, 0, addr TextBuff
			
			mov		eax, ProcessEntry.th32DefaultHeapID
			invoke	wsprintf, addr TextBuff, addr HexFmt, eax
			invoke	SendDlgItemMessage, hWnd, IDC_WNDHEAPIDSTC, WM_SETTEXT, 0, addr TextBuff
			
			invoke	CloseHandle, hSnapshot
			
		.endif
		
		
	.elseif uMsg==WM_CLOSE
		
		invoke	EndDialog, hWnd, 0
		
	.else
		
		mov		eax, FALSE
		ret
		
	.endif
	
	mov		eax, TRUE
	ret

WndPprtProcessDlg endp


SendMessageDlg proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL	SMhWnd		:DWORD
	LOCAL	SMMsg		:DWORD
	LOCAL	SMwParam	:DWORD
	LOCAL	SMlParam	:DWORD
	LOCAL	hWndEdit	:DWORD
	
	.if uMsg==WM_INITDIALOG
		
		invoke	wsprintf, addr TextBuff, addr HexFmt, hWndWindow
		invoke	SendDlgItemMessage, hWnd, IDC_SMHWNDEDT, WM_SETTEXT, 0, addr TextBuff
		
		invoke	GetDlgItem, hWnd, IDC_SMHWNDEDT
		mov		hWndEdit, eax
		invoke	SendMessage, eax, EM_SETLIMITTEXT, 8, 0
		invoke	SetWindowLong, hWndEdit, GWL_WNDPROC, addr EditWndSubClass
		invoke	SetWindowLong, hWndEdit, GWL_USERDATA, eax
		
		invoke	GetDlgItem, hWnd, IDC_SMWPARAMEDT
		mov		hWndEdit, eax
		invoke	SendMessage, eax, EM_SETLIMITTEXT, 8, 0
		invoke	SetWindowLong, hWndEdit, GWL_WNDPROC, addr EditWndSubClass
		invoke	SetWindowLong, hWndEdit, GWL_USERDATA, eax
		
		invoke	GetDlgItem, hWnd, IDC_SMLPARAMEDT
		mov		hWndEdit, eax
		invoke	SendMessage, eax, EM_SETLIMITTEXT, 8, 0
		invoke	SetWindowLong, hWndEdit, GWL_WNDPROC, addr EditWndSubClass
		invoke	SetWindowLong, hWndEdit, GWL_USERDATA, eax
		
		invoke	FillMessagesData, hWnd
		
	.elseif uMsg==WM_COMMAND
		
		mov		edx,wParam
		movzx	eax,dx
		shr		edx,16
		
		.if edx==BN_CLICKED
			
			.if eax==IDC_SENDMESSAGEBTN
				
				invoke	IsDlgButtonChecked, hWnd, IDC_HWNDBRDCHK
				.if eax==BST_UNCHECKED
					invoke	SendDlgItemMessage, hWnd, IDC_SMHWNDEDT, WM_GETTEXT, 9, addr TextBuff
					invoke	htodw, addr TextBuff
				.else
					mov		eax, HWND_BROADCAST
				.endif
				mov		SMhWnd, eax
				invoke	SendDlgItemMessage, hWnd, IDC_SMMSGCBO, CB_GETCURSEL, 0, 0
				.if eax==-1
					invoke	SendDlgItemMessage, hWnd, IDC_SMMSGCBO, WM_GETTEXT, 9, addr TextBuff
					invoke	htodw, addr TextBuff
				.else
					invoke	SendDlgItemMessage, hWnd, IDC_SMMSGCBO, CB_GETITEMDATA, eax, 0
				.endif
				mov		SMMsg, eax
				invoke	SendDlgItemMessage, hWnd, IDC_SMWPARAMEDT, WM_GETTEXT, 9, addr TextBuff
				invoke	htodw, addr TextBuff
				mov		SMwParam, eax
				invoke	SendDlgItemMessage, hWnd, IDC_SMLPARAMEDT, WM_GETTEXT, 9, addr TextBuff
				invoke	htodw, addr TextBuff
				mov		SMlParam, eax
				
				; Send Message to target Window Handle
				invoke	SendMessage, SMhWnd, SMMsg, SMwParam, SMlParam ;
				invoke	wsprintf, addr TextBuff, addr HexShortFmt, eax
				invoke	SendDlgItemMessage, hWnd, IDC_SMLRESULTEDT, WM_SETTEXT, 0, addr TextBuff
				
				
			.elseif eax==IDC_HWNDBRDCHK
				
				invoke	IsDlgButtonChecked, hWnd, IDC_HWNDBRDCHK
				xor		eax, 1
				invoke	EnableDlgWindow, hWnd, IDC_SMHWNDEDT, eax
				
			.elseif eax==IDCANCEL
				
				invoke	SendMessage, hWnd, WM_CLOSE, NULL, NULL
				
			.endif
			
		.endif
		
	.elseif uMsg==WM_CLOSE
		
		invoke	EndDialog, hWnd, lParam
		
	.else
		
		mov		eax, FALSE
		ret
		
	.endif
	
	mov		eax, TRUE
	ret

SendMessageDlg endp


SetWindowPosDlg proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL	rect		:RECT
	LOCAL	pt			:POINT	
	LOCAL	WndWidth	:DWORD
	LOCAL	WndHeight	:DWORD
	
	.if uMsg==WM_INITDIALOG
		
		invoke	GetSystemMetrics, SM_CXSCREEN
		push	eax
		invoke	SendDlgItemMessage, hWnd, IDC_LEFTUDN, UDM_SETRANGE32, 0, eax
		pop		eax
		invoke	SendDlgItemMessage, hWnd, IDC_WIDTHUDN, UDM_SETRANGE32, 0, eax
		
		invoke	GetSystemMetrics, SM_CYSCREEN
		push	eax
		invoke	SendDlgItemMessage, hWnd, IDC_TOPUDN, UDM_SETRANGE32, 0, eax
		pop		eax
		invoke	SendDlgItemMessage, hWnd, IDC_HEIGHTUDN, UDM_SETRANGE32, 0, eax
		
		invoke	GetWindowRect, hWndWindow, addr rect
		mov		eax, rect.right
		sub		eax, rect.left
		mov		WndWidth, eax
		mov		eax, rect.bottom
		sub		eax, rect.top
		mov		WndHeight, eax
		invoke	GetWindowLong, hWndWindow, GWL_STYLE
		.if (eax & WS_CHILD)
			invoke	GetParent, hWndWindow
			.if eax!=0
				mov		edx, eax
				m2m		pt.x, rect.left
				m2m		pt.y, rect.top
				invoke	ScreenToClient, edx, addr pt
				invoke	GetClientRect, hWndWindow, addr rect
				m2m		WndWidth, rect.right
				m2m		WndHeight, rect.bottom
				m2m		rect.left, pt.x
				m2m		rect.top, pt.y
			.endif
		.endif
		
		invoke	SendDlgItemMessage, hWnd, IDC_LEFTUDN, UDM_SETPOS, 0, rect.left
		invoke	SendDlgItemMessage, hWnd, IDC_TOPUDN, UDM_SETPOS, 0, rect.top
		invoke	SendDlgItemMessage, hWnd, IDC_WIDTHUDN, UDM_SETPOS, 0, WndWidth
		invoke	SendDlgItemMessage, hWnd, IDC_HEIGHTUDN, UDM_SETPOS, 0, WndHeight
		
		
	.elseif uMsg==WM_COMMAND
		
		mov		edx,wParam
		movzx	eax,dx
		shr		edx,16
		
		.if edx==BN_CLICKED
			
			.if eax==IDOK
				
				push	TRUE
				invoke	SendDlgItemMessage, hWnd, IDC_HEIGHTUDN, UDM_GETPOS, 0, 0
				push	eax
				invoke	SendDlgItemMessage, hWnd, IDC_WIDTHUDN, UDM_GETPOS, 0, 0
				push	eax
				invoke	SendDlgItemMessage, hWnd, IDC_TOPUDN, UDM_GETPOS, 0, 0
				push	eax
				invoke	SendDlgItemMessage, hWnd, IDC_LEFTUDN, UDM_GETPOS, 0, 0
				push	eax
				push	hWndWindow
				call	MoveWindow
				
			.elseif eax==IDCANCEL
				
				invoke	SendMessage, hWnd, WM_CLOSE, NULL, NULL
				
			.endif
			
		.endif
		
	.elseif uMsg==WM_CLOSE
		
		invoke	EndDialog, hWnd, lParam
		
	.else
		
		mov		eax, FALSE
		ret
		
	.endif
	
	mov		eax, TRUE
	ret

SetWindowPosDlg endp


TransparentDlg proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	
	.if uMsg==WM_INITDIALOG
		
		m2m		hWndDialog, lParam
		
		invoke	SendDlgItemMessage, hWnd, IDC_TRANSTRB, TBM_SETRANGEMIN, FALSE, 0
		invoke	SendDlgItemMessage, hWnd, IDC_TRANSTRB, TBM_SETRANGEMAX, FALSE, 255
		invoke	GetWindowTransparent, hWndDialog
		.if eax!=0
			mov		ecx, 255
			sub		ecx, eax
			mov		eax, ecx
		.endif 
		invoke	SendDlgItemMessage, hWnd, IDC_TRANSTRB, TBM_SETPOS, TRUE, eax
		invoke	SendMessage, hWnd, WM_HSCROLL, 0, 0
		
	.elseif uMsg==WM_COMMAND
		
		mov		edx,wParam
		movzx	eax,dx
		shr		edx,16
		
		.if edx==BN_CLICKED
			
			.if eax==IDOK
				
				invoke	SendDlgItemMessage, hWnd, IDC_TRANSTRB, TBM_GETPOS, 0, 0
				mov		ecx, 255
				sub		ecx, eax
				invoke	SetWindowTransparent, hWndDialog, ecx
				
			.elseif eax==IDCANCEL
				
				invoke	SendMessage, hWnd, WM_CLOSE, NULL, NULL
				
			.endif
			
		.endif
		
	.elseif uMsg==WM_HSCROLL
		
		invoke	SendDlgItemMessage, hWnd, IDC_TRANSTRB, TBM_GETPOS, 0, 0
		invoke	wsprintf, addr TextBuff, addr PersenFmt, eax
		invoke	SendDlgItemMessage, hWnd, IDC_TRANSSTC, WM_SETTEXT, 0, addr TextBuff 
		
	.elseif uMsg==WM_CLOSE
		
		invoke	EndDialog, hWnd, lParam
		
	.else
		
		mov		eax, FALSE
		ret
		
	.endif
	
	mov		eax, TRUE
	ret

TransparentDlg endp


SendTextDlg proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL	rect	:RECT
	
	
	.if uMsg==WM_INITDIALOG
		
		invoke	CheckRadioButton, hWnd, IDC_SHORTTEXTRBN, IDC_LONGTEXTRBN, IDC_SHORTTEXTRBN
		
		invoke	SendDlgItemMessage, hWnd, IDC_SHORTTEXTEDT, EM_LIMITTEXT, 255, 0
		invoke	SendMessage, hWndWindow, WM_GETTEXT, 256, addr TextBuff
		invoke	SendDlgItemMessage, hWnd, IDC_SHORTTEXTEDT, WM_SETTEXT, 0, addr TextBuff
		
		
	.elseif uMsg==WM_COMMAND
		
		mov		edx,wParam
		movzx	eax,dx
		shr		edx,16
		
		.if edx==BN_CLICKED
			
			.if eax==IDOK
				
				invoke	IsDlgButtonChecked, hWnd, IDC_SHORTTEXTRBN
				.if eax==BST_CHECKED
					invoke	SendDlgItemMessage, hWnd, IDC_SHORTTEXTEDT, WM_GETTEXT, 255, addr TextBuff
					.if eax!=0
						invoke	SendMessage, hWndWindow, WM_SETTEXT, 0, addr TextBuff
					.endif
				.else
					invoke	SendDlgItemMessage, hWnd, IDC_LONGTEXTEDT, WM_GETTEXT, 255, addr TextBuff
					.if eax!=0
						invoke	SendTextFromFile, hWnd, addr TextBuff
					.endif
				.endif
				
			.elseif eax==IDCANCEL
				
				invoke	SendMessage, hWnd, WM_CLOSE, NULL, NULL
				
			.elseif eax==IDC_SHORTTEXTRBN
				
				invoke	EnableDlgWindow, hWnd, IDC_SHORTTEXTEDT, TRUE
				invoke	EnableDlgWindow, hWnd, IDC_LONGTEXTBTN, FALSE
				
			.elseif eax==IDC_LONGTEXTRBN
				
				invoke	EnableDlgWindow, hWnd, IDC_SHORTTEXTEDT, FALSE
				invoke	EnableDlgWindow, hWnd, IDC_LONGTEXTBTN, TRUE
				
			.elseif eax==IDC_LONGTEXTBTN
				
				invoke	ShowOpenDialog, hWnd, addr TextFilesFilter, 0, addr FileNameBuff
				.if eax!=0
					invoke	SendDlgItemMessage, hWnd, IDC_LONGTEXTEDT, WM_SETTEXT, 0, addr FileNameBuff
				.endif
				
			.endif
			
		.endif
		
	.elseif uMsg==WM_CLOSE
		
		invoke	EndDialog, hWnd, lParam
		
	.else
		
		mov		eax, FALSE
		ret
		
	.endif
	
	mov		eax, TRUE
	ret

SendTextDlg endp


AboutDlg proc uses ebx esi hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL	lft			:LOGFONT
	LOCAL	hUrlFont	:DWORD
	
	mov		eax, uMsg
	
	.if eax==WM_INITDIALOG
		
		invoke	LoadIcon, hInstance, IDR_MAINICON
		invoke	SendDlgItemMessage, hWnd, IDC_LOGOIMG, STM_SETIMAGE, IMAGE_ICON, eax
		
		invoke	GetDlgItem, hWnd, IDC_EMAILSTC
		mov		hAboutEmail, eax
		
		mov		TextBuff, 0
		invoke	GetSystemOwner, addr TextBuff, NTPlatformId
		invoke	SendDlgItemMessage, hWnd, IDC_SYSTEMOWNERSTC, WM_SETTEXT, 0, addr TextBuff
		
		invoke	SendMessage, hWnd, WM_GETFONT, 0, 0
		mov		hUrlFont, eax
		invoke	GetObject, hUrlFont, sizeof LOGFONT, addr lft
		mov		lft.lfUnderline, 1
		invoke	CreateFontIndirect, addr lft
		mov		hUrlFont, eax
		invoke	SendMessage, hAboutEmail, WM_SETFONT, hUrlFont, TRUE
		
		mov		lft.lfUnderline, 0
		mov		lft.lfWeight, FW_BOLD
		invoke	CreateFontIndirect, addr lft
		mov		hUrlFont, eax
		invoke	SendDlgItemMessage, hWnd, IDC_PROGNMSTC, WM_SETFONT, hUrlFont, TRUE
		
		
	.elseif eax==WM_COMMAND
		
		mov		eax, wParam
		mov		edx, eax
		shr		edx, 16
		and		eax, 0FFFFh
		
		.if edx==BN_CLICKED
			.if eax==IDOK || eax==IDCANCEL
				invoke	SendMessage, hWnd, WM_CLOSE, NULL, NULL
			.endif
		.endif
		
	.elseif uMsg==WM_CTLCOLORSTATIC
		
		mov		eax, lParam
		.if eax==hAboutEmail
			invoke	SetTextColor, wParam, 00A00000h
			invoke	SetBkMode, wParam, TRANSPARENT
			invoke	GetStockObject, HOLLOW_BRUSH 
			ret
		.endif		
		mov		eax,FALSE
		ret		
		
	.elseif eax==WM_MOUSEMOVE
		
		mov		edx, lParam
		movzx	eax, dx
		shr		edx, 16
		invoke	ChildWindowFromPoint, hWnd, eax, edx
		.if eax==hAboutEmail
			invoke	LoadCursor, 0, IDC_HAND
			invoke	SetCursor, eax
			ret
		.endif
		
	.elseif eax==WM_LBUTTONUP
		
		mov		edx, lParam
		movzx	eax, dx
		shr		edx, 16
		invoke	ChildWindowFromPoint, hWnd, eax, edx
		.if eax==hAboutEmail
			mov		dword ptr [TextBuff], 'liam'
			mov		dword ptr [TextBuff+4], ':ot'
			invoke	SendMessage, eax, WM_GETTEXT, 256, addr TextBuff+7
			invoke	ShellExecute, hWnd, addr szOpen, addr TextBuff, 0, 0, SW_SHOWNORMAL
		.endif
		
	.elseif eax==WM_CLOSE
		
		invoke	EndDialog, hWnd, 0
		
	.else
		
		mov		eax,FALSE
		ret
		
	.endif
	
	mov		eax,TRUE
	ret

AboutDlg endp


EditWndSubClass proc hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	LOCAL	OldWndProc	:DWORD

	invoke	GetWindowLong, hWnd, GWL_USERDATA
	mov		OldWndProc, eax
	
	.if uMsg==WM_CHAR
		mov		eax, wParam
		.if (al>="0" && al<="9") || (al>="A" && al<="F") || (al>="a" && al<="f") || al==VK_BACK
			.if al>="a" && al<="f"
				sub al,20h
			.endif
			invoke	CallWindowProc, OldWndProc, hWnd, uMsg, eax, lParam
			ret
		.endif
	.else
		invoke	CallWindowProc, OldWndProc, hWnd, uMsg, wParam, lParam
	.endif
	ret

EditWndSubClass endp


end start

